
/***************************************************
* C source with CCS
*  File Name: 20120401_MK313_temperature_sensor.c
*  Description: check potentiometer and NTC sensor out
*  , and turn on yellow LED and relay
*  PIN A0 na
*  PIN A1 for potentiometer
*  PIN A2 for NTC
*  PIN A3 for start
*  PIN A4 for Relay
*  PIN A5 for LED
*  COPYRIGHT 2012 MYCOMKITS.COM, owned by CNET LIMITED
*  vO̒쌠́Aҁu}CRLbghbgR^c@LЃNlbgvɋA܂B
*  쌠Ă܂񂪁AvOgwK̒ŃvORɕύXĂgB
***************************************************/
// include header file
#include   <12f683.h>
#DEVICE ADC=10
//#include <stdlib.h>

// settings
#fuses   INTRC_IO, NOWDT, NOPUT, NOPROTECT, NOMCLR
#use delay(CLOCK = 4000000)
//
long value_setting=512;
long value_sensor=512;
long value_s[17];
int hyste = 0;
int i;
int m;
int n;
float b_const = 3452;
//float Rvalue;
//float log_data2;
float actual_temp;
//float sensor_f;
float log_data;
float rt_temp;

//
// LOG calclation table
const float r_value[20] = {109121.5436, 63185.33369, 37994.24658, 23635.92567, 15161.78685, 10000, 6764.289855, 4682.171292,
   3309.912751, 2385.430628, 1749.917183, 1304.847807, 987.7513058, 758.2094321, 589.5776639, 463.9827971,
    369.239262, 269.9123, 241.0803, 197.53};
const float log_value[20] = {11.60021762, 11.05382749, 10.54519002, 10.07052311, 9.626533518, 9.210340372, 8.819412562,
   8.451517233, 8.104677109, 7.777134944, 7.467323742, 7.17384169, 6.895430951, 6.630959643, 6.379406457, 6.139847476,
   5.911444841, 5.693437, 5.48513, 5.285891};
//
// prototyping
#separate
void get_sensor();
#separate
void get_setting();
#separate
void initializing();
#separate 
float log_calc();
//
//
// main
//
void main()
{
   //
   initializing();   //ADC port initialize
   output_low(PIN_A4);   //active high, Relay off
   output_high(PIN_A5);   //active low, LED off
   //
   // main loop
   while(1)   
   {
      if(input(PIN_A3)==1) 
      {
         delay_ms(50);   //check it again for chattaling
         if(input(PIN_A3)==1) 
         {
            /*
            while(1)
            {
               test();
            }   
            */
            //
            get_setting();
            get_sensor();
            //
            if(value_sensor > value_setting*0.9) 
            {
               output_low(PIN_A5);   // LED on
            }
            else
            {
               output_high(PIN_A5);   // LED off
            }   
            if(value_sensor > value_setting) 
            {
               
               if(hyste == 0) 
               {
                  output_high(PIN_A4);   // Relay on
                  hyste = 50;
               }   
            }
            //else
            else if(hyste == 0)
            {
               output_low(PIN_A4);   // Relay off
               hyste = 50;
            }                                    
         }         
      }         
   }
}
//
//
#separate
void get_setting()
{
   set_adc_channel(1);   //must wait 65u
   delay_us(100);
   value_setting=read_adc();   // 0 to 1024, 0.3V to 3.3V
}   
//
#separate
void get_sensor()
{
   // moving average
   int i;
   for (i=15; i>0; i--)
   {
      value_s[i] = value_s[i-1];
   }   
   set_adc_channel(2);   //must wait 65u
   delay_us(100);
   value_s[0] = read_adc();   //0 to 1024, 0.3V to 5V
   //
   value_sensor = 0;
   for (i=0; i<16; i++)
   {
      value_sensor = value_sensor + value_s[i];
   }   
   //
   rt_temp = value_sensor;   // 16 times of actual value, almost real register
   m=0;
   //
   while(rt_temp < r_value[m]) 
   {
      m++;
   }
   //
   log_data = ((rt_temp-r_value[m])/(r_value[m-1]-r_value[m]))*(log_value[m-1]-log_value[m])+log_value[m];   
   //
   actual_temp = (1/((1/b_const)*(log_data-9.2103403)+0.003354))-273.15;
   value_sensor = (actual_temp-10)*10.72;   // adjust into 10 to 140 degree
   //value_sensor = actual_temp*5;   // -10 to 200 degree
   //
}   
//
// system intializing
//
#separate
void initializing() 
{
   //
   SET_TRIS_A(0x0F);   //A0 to 3 are input, 4, 5 are output
   //    
   // A/D converter initialize AN1 and AN2
   setup_adc_ports(sAN1 | sAN2 | VSS_VDD);   // gnd to 5v
   setup_adc(ADC_CLOCK_DIV_8);         // 2usec
   //
   // timer 1 intialize for hysteresis count down
   //
   setup_timer_1(T1_INTERNAL|T1_DIV_BY_8);
   set_timer1(0xF4F0);              // timer 1 setting almost 5msec
   enable_interrupts(INT_TIMER1);   // timer 1 enable
   enable_interrupts(GLOBAL);       // global enable
   //
   //
}
//
// timer 1 inturruption
// hysteresis count down 
//
#int_timer1
void isr1(void)   
{
   set_timer1(0xF4F0);             // timer 1 almost 5msec
   //
   if(hyste > 1) hyste = hyste - 1;
   else hyste = 0;   
   //
}   
//
// supply LOG data by table
#separate 
void log_calc() 
{
   int m=0;
   int n=0;
   //float log_data;
   //
   while(rt_temp < r_value[m]) 
   {
      m++;
      n=m;
   }
   log_data = ((rt_temp-r_value[m])/(r_value[m-1]-r_value[m]))*(log_value[m-1]-log_value[m])+log_value[m];   
   //
   //return log_data;
}   
//
